/*
 * Copyright (C) 2012 Spreadtrum Communications Inc.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef	_ION_SPRD_H
#define _ION_SPRD_H

#define ION_HEAP_ID_SYSTEM	1
#define ION_HEAP_ID_MM		2
#define ION_HEAP_ID_OVERLAY	3
#define ION_HEAP_ID_GSP		4
#ifdef CONFIG_SPRD_IOMMU
#define ION_HEAP_ID_IOMMU		16
#endif

#define ION_HEAP_ID_MASK_SYSTEM 	(1<<ION_HEAP_ID_SYSTEM)
#define ION_HEAP_ID_MASK_MM		(1<<ION_HEAP_ID_MM)
#define ION_HEAP_ID_MASK_OVERLAY	(1<<ION_HEAP_ID_OVERLAY)
#define ION_HEAP_ID_MASK_GSP	(1<<ION_HEAP_ID_GSP)
#ifdef CONFIG_SPRD_IOMMU
#define ION_HEAP_ID_MASK_IOMMU	(1<<ION_HEAP_ID_IOMMU)
#endif


#define ION_DRIVER_VERSION	1

struct ion_phys_data {
	int fd_buffer;
	unsigned long phys;
	size_t size;
};

struct ion_mmu_data {
	int fd_buffer;
	unsigned long iova_addr;
	size_t iova_size;
};

struct ion_msync_data {
	int fd_buffer;
	void *vaddr;
	void *paddr;
	size_t size;
};

struct ion_map_data {
	int fd_buffer;
	unsigned long dev_addr;
};

struct ion_unmap_data {
	int fd_buffer;
};

struct ion_fence_data {
    int fence_fd;
    char name[32];
    unsigned long value;
};

enum ION_SPRD_CUSTOM_CMD {
	ION_SPRD_CUSTOM_PHYS,
	ION_SPRD_CUSTOM_MSYNC,

	/* to get/free mmu iova */ //added by yfs
	ION_SPRD_CUSTOM_GSP_MAP,
	ION_SPRD_CUSTOM_GSP_UNMAP,
	ION_SPRD_CUSTOM_MM_MAP,
	ION_SPRD_CUSTOM_MM_UNMAP,
        ION_SPRD_CUSTOM_FENCE_CREATE,
        ION_SPRD_CUSTOM_FENCE_SIGNAL,
        ION_SPRD_CUSTOM_FENCE_DUP,
};

struct ion_client *sprd_ion_client_create(const char *name);

#if defined(CONFIG_SPRD_IOMMU)
int sprd_map_iommu(struct ion_handle *handle, int domain_num,
						unsigned long *ptr_iova);
int sprd_unmap_iommu(struct ion_handle *handle, int domain_num);
#endif

#endif /* _ION_SPRD_H */
